angular.module('stigv1.controllers.propedit', [])


    .controller('DisAddPropositionController', function ($scope, Login, Config, $location, $ionicContentBanner) {


        $scope.adddata = {};


        if (!Login.isLogged()) {
            $location.path('/entry/subscribe');
        }


        $scope.goAdd = function () {


            $scope.adddata.ischecked = false;

            Config.setScope('national');

            $location.path('/app/propositions/dis2');

        };

        $scope.goAddLocal = function () {


            Config.setScope('local');
            $scope.adddata.ischecked = false;
            $location.path('/app/propositions/dis2');

        };

        $scope.goAddLocalFback = function () {


            Config.setScope('local');
            $scope.adddata.ischecked = false;
            $location.path('/app/propositions/dis2').search({cat:17});

        };

    })


    .controller('AddPropositionController', function ($scope, $rootScope,$state, Login, $http, Config, Categories, Town, Backend, $location, $ionicHistory, $stateParams, Proposition, $ionicContentBanner, $timeout, $ionicModal) {


        if (!Login.isLogged()) {
            $location.path('/entry');
        }


        $scope.sending = true;
        $scope.editMode = false;


        $scope.propData = {};

        //console.info($location.search())


        $scope.onDelete = function(){
            console.log("On Delete ", $stateParams);
        }



        $scope.onDraft = function () {
            console.log('draft', false, $scope.propData);


            $scope.doSendData(true);


        };


        $scope.onProd = function () {
            console.log('submit', true, $scope.propData);


            $scope.doSendData(false);


        };


        $scope.doSendData = function (bDraft) {


            console.info($scope.propData);


            var aErrors = [];


            if (!$scope.propData.idcategory) {
                aErrors.push('Veuillez selectionner une catégorie');
            }


            if (!$scope.propData.title) {

                aErrors.push("Vous n'avez pas saisi de synthèse");


            }


            if ($scope.propData.title && ($scope.propData.title.length < 5)) {


                aErrors.push("La synthèse semble trop courte pour être intelligible");

            }



            if (aErrors.length > 0) {

                $ionicContentBanner.show({
                    text: [aErrors[0]],

                    autoClose: 2600,
                    type: 'error',
                    transition: 'vertical'
                });

                return;

            }

            //TEST pout valide simple du formulaire
            //return;

            $scope.sending = true;

            sMethod = "POST";

            if ($scope.editMode) {
                sMethod = "PUT";
            }


            console.info($scope.editMode, sMethod);

            //return;

            var req = {
                method: sMethod,
                data: {
                    'idcategory': $scope.propData.idcategory,
                    'title': $scope.propData.title,
                    'desc': $scope.propData.description,
                    'finance': $scope.propData.financement,
                    'draft': bDraft ? 1 : 0,
                    'zone': $scope.propData.idzone,
                    'scope': Config.getScope(),
                    'idprop': $scope.prop ? $scope.prop.uid : null
                },
                url: Backend.makeURL('proposition/', true)
            };



            $http(req).success(function (data, status) {

                console.log('Prop Inserted :', data, status);


                if ($scope.editMode) {

                    if (bDraft) {


                        $ionicContentBanner.show({
                            text: ['Brouillon enregistré'],

                            autoClose: 2600,
                            type: 'info',
                            transition: 'vertical'
                        });

                        $rootScope.refreshdrafts = Math.random();
                        //$location.path('/app/drafts');

                    } else {

                        $scope.propData = {};
                        $scope.propData.idcategory = 0;

                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });

                        $rootScope.refreshdrafts = Math.random();
                        $rootScope.refreshprops = Math.random();
                        //$location.path('/app/propositions/recent');
                        $state.go('app.propositionsrecent');
                    }

                } else {

                    if (bDraft) {

                        $ionicContentBanner.show({
                            text: ['Brouillon enregistré'],

                            autoClose: 2600,
                            type: 'info',
                            transition: 'vertical'
                        });


                        $scope.proposition = data.results[0];
                        $scope.prop = $scope.proposition;

                        if (data.uid) {
                            //$stateParams.propId = data.uid;
                            $scope.editMode = true;
                        }


                        $rootScope.refreshdrafts = Math.random();
                        //$location.path('/app/drafts');


                    } else {

                        $scope.propData = {};
                        $scope.propData.idcategory = 0;

                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });


                        $rootScope.refreshdrafts = Math.random();
                        $rootScope.refreshprops = Math.random();
                        //$location.path('/app/propositions/recent');
                        $state.go('app.propositionsrecent');
                    }


                }

                $scope.sending = false;


            });


        };



        //$scope.propData.idcategory = 0;

        $scope.categories = [];
        $scope.zones = [];


        //$scope.idzone = "34"

        $scope.$watch('statescope', function (news, olds) {

            console.log('change scope : ', news, olds);

            $scope.updateCategs();
            $scope.updateZones();

        });

        $scope.updateZones = function () {

            Town.getZones().success(function (data, status) {

                $scope.zones = data.results;

            });

        };


        $scope.updateCategs = function () {

            (Config.getScope() == 'local' ? Categories.getLocal() : Categories.getNational()).success(function (data, status) {

                $scope.categories = data.results;


                if($location.search().cat){

                    $timeout(function(){


                        $scope.propData.idcategory = ($location.search().cat);
                        console.log('ID category : ',$scope.propData.idcategory);

                    },20);

                } else {
                    if(!$scope.editMode){
                        $scope.propData.idcategory = 0;
                    }

                }


            });

        };


        $scope.$watch('forceinitProp', function(n, o){

            console.log('watch.forceinitProp !', n , o);
            if(n && n != o && $scope.controllerInit){

                console.info("Besoin de mettre à jour le Scope");

                $scope.initProp();

            }


        });


        $scope.controllerInit = false;


        $scope.initProp = function() {


            console.log('initProp !');


            $scope.controllerInit = true;

            if ($stateParams.propId) {


                $scope.editMode = true;
                $scope.sending = true;


                Proposition.getById($stateParams.propId).success(function (data, status) {


                    if (data.results && data.results.length) {
                        $scope.loaded = true;
                        $scope.proposition = data.results[0];
                        $scope.prop = $scope.proposition;


                        $scope.propData.uid = $scope.prop.uid;
                        $scope.propData.idcategory = $scope.prop.catid.toString();
                        $scope.propData.title = $scope.prop.title;
                        $scope.propData.description = $scope.prop.description;
                        $scope.propData.financement = $scope.prop.financement;

                        //$scope.propData.idzone


                        Config.setScope($scope.prop.scope);
                        $scope.sending = false;


                    } else {
                        $scope.loaded = true;
                        $scope.proposition = {};
                        $scope.prop = $scope.proposition;
                    }


                });


            } else {
                $scope.sending = false;
            }


        }

        $scope.initProp();

        /**

        //Partie consacrée à l'intersticiel de Bravo c'est posté !



        // Create the login modal that we will use later
        $ionicModal.fromTemplateUrl('templates/propaddedmodal.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.modalcongrat = modal;
        });

        // Triggered in the login modal to close it
        $scope.closeReport = function () {
            $scope.modalcongrat.hide();

            //Penser à changer de page
        };



        $scope.openCongrat = function ($event, id) {


            console.info(this, $event, id);

            //$rootScope.globalOpenReport($event, id, 'proposition');



        };


        $scope.congrat = {};
        $scope.congrat.type = 0;
        $scope.congrat.content = "";

        $scope.onSubmitCongrat = function (form) {


            //Usefull ???


        };




        /**/


    })

;

