angular.module('stigv1.controllers.random', [])


    .controller('RandomPropositionController', function ($scope, Login, TDCardDelegate, cardHelper, $document, $timeout, $rootScope, Proposition, Vote, $location, $ionicContentBanner, $ionicSideMenuDelegate) {


        $scope.windowHeight = window.screen.height;

        $scope.launcher = true;

        //console.info('RandomPropositionController init !', TDCardDelegate);


        $scope.order = "random";

        $scope.$watch('statescope', function (news, olds) {

            if (news && olds && (news != olds)) {

                $scope.init();

            }

        });



        $scope.empty = false;


        $scope.letSwipe = function($event){



            if(!Login.isLogged()){


                $rootScope.openLoginPopin($event);


                return;
            }

            $ionicSideMenuDelegate.canDragContent(true);

        }


        $scope.stopSwipe = function(){
            $ionicSideMenuDelegate.canDragContent(false);
        }


        $scope.$watch('cards.active', function(news, olds){

            console.log('cards.active', news,olds);

            if(!$scope.empty && (news && news.length == 0) && (news != olds)){

                $scope.init();

                $scope.empty = true;
                $scope.launcher = true;
            }

        },true);




        var cardTypes = [

        ];

        $scope.cards = {
            master: [],
            active: [],
            discards: [],
            liked: [],
            disliked: []
        };




        $scope.moreInfos = function(id){

            console.log('More Infos : ', id);

            //$location.path('/app/propositions/'+id);

        };


        $scope.init = function () {

            Proposition.getByOrder('random').success(function(data){

                //console.table(data.results)


                $scope.empty = false;

                $scope.cards.active = null;

                $scope.launcher = true;

                $timeout(function() {

                    $scope.launcher = false;

                    if(data.results.length > 0){

                        $scope.cards.master = Array.prototype.slice.call(data.results, 0);
                        $scope.cards.active = Array.prototype.slice.call(data.results, 0);

                    } else {


                        $scope.empty = true;

                        $scope.cards.master = Array.prototype.slice.call([], 0);
                        $scope.cards.active = Array.prototype.slice.call([], 0);

                    }


                    console.log($scope.cards.active)
                });


            });


        };

        $scope.nextCard = function () {
            var currentCard = $document[0].getElementsByTagName('td-card')[0];
            cardHelper.animationFly(currentCard, $scope.cards.active);
        };

        $scope.actionVote = function ($event, choice) {

            if(!Login.isLogged()){


                $rootScope.openLoginPopin($event);


                return;
            }



            if (!choice) {
                return;
            }

            var currentCard = $document[0].getElementsByTagName('td-card')[0];

            switch (choice) {
                case 'yes':
                    $scope.cardSwipedRight(0);
                    setOpacity('yes');
                    cardHelper.animationFly(currentCard, $scope.cards.active, 'right');
                    break;
                case 'no':
                    $scope.cardSwipedLeft(0);
                    setOpacity('no');
                    cardHelper.animationFly(currentCard, $scope.cards.active);
                    break;
            }
        };

        function setOpacity (choice) {
            $document[0].getElementsByClassName('iconCard')[0].style.opacity = 0;
            $document[0].getElementsByClassName(choice + '-text')[0].style.opacity = 1;
        }

        $scope.shareProposition = function ($event, id, title) {

            $rootScope.shareProposition($event, id,title);

        };

        $scope.cardDestroyed = function(index) {
            $scope.cards.active.splice(index, 1);
        };

        $scope.clickFavorite = function (event, uid, card) {

            console.log('Favorite : ', uid, $scope);

            if (!Login.isLogged()) {


                $rootScope.openLoginPopin(event);


                return;
            }

            $scope.favorite = card.favorite;

            //$scope.prop.favorite = $scope.favorite == "1" ? 1 : 0;

            if ($scope.favorite == "0") {
                Proposition.favorite(uid);

                $ionicContentBanner.show({
                    text: ['Ajouté aux favoris'],

                    autoClose: 2600,
                    type: 'info',
                    transition: 'vertical'
                });

                card.favorite = "1";

                $rootScope.refreshfavorites = Math.random();

            } else {

                $ionicContentBanner.show({
                    text: ['Supprimé des favoris'],

                    autoClose: 2600,
                    type: 'info',
                    transition: 'vertical'
                });

                card.favorite = "0";

                Proposition.unfavorite(uid);
                $rootScope.refreshfavorites = Math.random();
            }


        };

        $scope.refreshCards = function() {
            // Set $scope.cards to null so that directive reloads


            $scope.init();


        };


        $scope.$on('removeCard', function(event, element, card) {
            var discarded = $scope.cards.master.splice($scope.cards.master.indexOf(card), 1);
            $scope.cards.discards.push(discarded);


            console.info("la pile de card : ", $scope.cards.master, $scope.cards.master.length);

        });

        $scope.cardSwipedLeft = function(index) {
            console.log('LEFT SWIPE');

            if(!Login.isLogged()){
                return;
            }

            var card = $scope.cards.active[index];

            Vote.addVote(card.uid, 'minus', false).success(function (data, status) {

                //console.info('retour de vote', data, this, $ionicContentBanner, $scope);

                if (data.results && data.results.length >= 0) {

                }

            });



            $scope.cards.disliked.push(card);
        };
        $scope.cardSwipedRight = function(index) {
            console.log('RIGHT SWIPE');

            if(!Login.isLogged()){
                return;
            }

            var card = $scope.cards.active[index];

            Vote.addVote(card.uid, 'plus', false).success(function (data, status) {
                //console.info('retour de vote', data, this, $ionicContentBanner, $scope);

                if (data.results && data.results.length >= 0) {

                }

            });



            $scope.cards.liked.push(card);
        };


        $scope.init();


    })

    .controller('CardCtrl', function($scope, TDCardDelegate) {

    });







