angular.module('stigv1.controllers', [])


    .controller('TutorialController', function ($scope, $ionicSlideBoxDelegate, $location, $ionicHistory, $window) {


        console.log(this, "Enter Tuto Controller");


        $scope.nextSlide = function () {
            $ionicSlideBoxDelegate.$getByHandle('slidetutorial').next();
        };


        $scope.closeTuto = function () {


            $ionicHistory.nextViewOptions({
                historyRoot: true
            });
            $location.path('/app/propositions/top');


            $ionicSlideBoxDelegate.$getByHandle('slidetutorial').slide(0, 0.1);
        };


        $scope.goBack = function () {

            history.back();
            //$scope.apply();

        }

    })



    .controller('AppCtrl', function ($scope, $rootScope, $timeout, User) {
        // Form data for the login modal

        console.info('Enter Menu Controller');

        $rootScope.shownNotif = false;


        $scope.notifs = [
            {
                new: true,
                text: "Stéphanie LECOURTOIS s'est abonné a votre profil",
                type: "follow",
                icon: "ion-person-add",
                target: ""

            },
            {
                new: true,
                text: "Naimreg DEVOURTOIS a déposé un nouvel amendement",
                type: "amendement",
                icon: "stigicon-amendements",
                target: ""

            },
            {
                new: false,
                text: "Vincent COQUOIN s'est abonné a votre profil",
                type: "follow",
                icon: "ion-person-add",
                target: ""

            },
            {
                new: false,
                text: "Laurent LOMBARD s'est abonné a votre profil",
                type: "follow",
                icon: "ion-person-add",
                target: ""

            },
            {
                new: false,
                text: "Naimreg DEVOURTOIS a déposé un nouvel amendement",
                type: "amendement",
                icon: "stigicon-amendements",
                target: ""

            },
            {
                new: false,
                text: "Naimreg DEVOURTOIS a déposé un nouvel amendement",
                type: "amendement",
                icon: "stigicon-amendements",
                target: ""

            }

        ];


        $rootScope.newNotifs = function () {

            return false;

        };


        $scope.toggleGroup = function () {
            if ($scope.isGroupShown()) {
                $rootScope.shownNotif = false;
            } else {
                $rootScope.shownNotif = true;
            }
        };
        $scope.isGroupShown = function (group) {
            return $rootScope.shownNotif;
        };


        $scope.isEluLocal = function () {
            return User.getGroup() == 1;
        };



    })





    //


    .controller('MyDraftsController', function ($scope, $rootScope, $location, Proposition, $state, $ionicScrollDelegate, $ionicNavBarDelegate, Config, $ionicContentBanner) {


        $scope.$watch('refreshdrafts', function (news, olds) {

            console.log('refresh add props : ', news, olds);
            if (news != olds) {
                $scope.load(true);
            }

        });


        $scope.load = function (empty) {


            $ionicScrollDelegate.scrollTop();


            if (empty) {
                $scope.propositions = [];
            }


            //

            $scope.loaded = false;

            Proposition.getMyDrafts().success(function (data, status) {

                $scope.propositions = data.results;

                //$scope.propositions = [];

                $scope.loaded = true;

            }).finally(function () {

                $scope.$broadcast('scroll.refreshComplete');
            });

        };


        $scope.load(true);


    })


    .controller('MyFavoritesController', function ($scope, $rootScope, $location, Proposition, $state, $ionicScrollDelegate, $ionicNavBarDelegate, Config) {


        $scope.$watch('refreshfavorites', function (news, olds) {

            console.log('refresh add props : ', news, olds);
            if (news != olds) {
                $scope.load(true);
            }

        });


        $scope.load = function (empty) {


            $ionicScrollDelegate.scrollTop();


            if (empty) {
                $scope.propositions = [];
            }


            //

            $scope.loaded = false;

            Proposition.getMyFavorites().success(function (data, status) {

                $scope.propositions = data.results;

                //$scope.propositions = [];

                $scope.loaded = true;

            }).finally(function () {

                $scope.$broadcast('scroll.refreshComplete');
            });

        };


        $scope.load(true);


    })


    .controller('MyVotesController', function ($scope, $rootScope, $location, Vote, $state, $ionicScrollDelegate, $ionicNavBarDelegate, Config) {




        $scope.loadOlderData = function () {


            console.log('Vote loadOlderData');


            var sLastId = '';

            if ($scope.votes.length > 0) {
                sLastId = $scope.votes[$scope.votes.length - 1].idvote;
            }


            Vote.getMyOlderVotes(sLastId).success(function (data, status) {


                if (data.results.length < 8 || data.results.length == 0) {
                    $scope.infiniteOk = false;
                }

                $scope.votes = $scope.votes.concat(data.results);


                $scope.$broadcast('scroll.infiniteScrollComplete');


                $scope.loaded = true;

            }).finally(function () {


            });


        };




        $scope.infiniteOk = true;

        $scope.load = function (empty) {

            $scope.infiniteOk = true;

            $ionicScrollDelegate.scrollTop();


            if (empty) {
                $scope.votes = [];
            }


            //

            $scope.loaded  = !empty;

            Vote.getMyVotes().success(function (data, status) {

                $scope.votes = data.results;
                //$scope.votes = [];


                $scope.loaded = true;

            }).finally(function () {

                $scope.$broadcast('scroll.refreshComplete');
            });

        };


        $scope.clickProp = function (id) {
            $location.path('/app/propositions/' + id)
        }

        $scope.load(true);


    })


    .controller('MyFluxController', function ($scope, $rootScope, $location, Proposition, $state, $ionicScrollDelegate, $ionicNavBarDelegate, Config) {


        $scope.order = "myflux";


        $scope.infiniteOk = true;

        $scope.loadOlderData = function () {


            console.log('loadOlderData Flux');

            var sPId = '';
            var sAId = '';
            var sVId = '';

            //Si on a des déjà des propositions
            if ($scope.propositions.length > 0) {


                var n = $scope.propositions.length;


                /**/

                for (var i = n - 1; i >= 0; i--) {

                    var pP = $scope.propositions[i];
                    if (sPId == '' && pP.type == 'proposition') {
                        sPId = pP.uid;
                    }
                    if (sAId == '' && pP.type == 'amendement') {
                        sAId = pP.uid;
                    }
                    if (sVId == '' && pP.type == 'vote') {
                        sVId = pP.idvote;
                    }

                }
                /**/

            }


            Proposition.getMyFlux(sPId, sAId, sVId).success(function (data, status) {


                if (data.results.length == 0) {
                    $scope.infiniteOk = false;
                }

                $scope.propositions = $scope.propositions.concat(data.results);


                $scope.$broadcast('scroll.infiniteScrollComplete');


                $scope.loaded = true;

            }).finally(function () {


            });


        };


        $scope.load = function (empty) {


            $ionicScrollDelegate.scrollTop();


            if (empty) {
                $scope.propositions = [];
            }


            //

            $scope.loaded = false;

            Proposition.getMyFlux('', '', '').success(function (data, status) {

                $scope.propositions = data.results;

                //$scope.propositions = [];

                $scope.loaded = true;

            }).finally(function () {

                $scope.$broadcast('scroll.refreshComplete');
            });

        };


        $scope.onUser = function (id) {

            var sPath = '/app/user/' + id;
            $location.path(sPath)
        };

        $scope.clickItem = function (id) {


            $location.path('/app/propositions/' + id);

        };


        $scope.load(true);


    })


    .controller('MyContributionsController', function ($scope, $rootScope, $location, Proposition, $state, $ionicScrollDelegate, $ionicNavBarDelegate, Config, $ionicLoading) {


        //$scope.order = "recent";


        $scope.transformAmemdement = function (id) {

            console.log('transformAmemdement : ', id);


            $ionicLoading.show();


            Proposition.transformAmemdement(id).success(function (data, status) {


                for (var i in $scope.propositions) {

                    if ($scope.propositions[i] && ($scope.propositions[i].amduid == id)) {
                        $scope.propositions.splice(i, 1);
                    }

                }


                $ionicLoading.hide();


            });
        };


        $scope.load = function (empty) {


            $ionicScrollDelegate.scrollTop();


            if (empty) {
                $scope.propositions = [];
            }


            //

            $scope.loaded = false;

            Proposition.getMyContributions().success(function (data, status) {

                $scope.propositions = data.results;

                //$scope.propositions = [];

                $scope.loaded = true;

            }).finally(function () {

                $scope.$broadcast('scroll.refreshComplete');
            });

        };


        $scope.load(true);


    })


;


