angular.module('stigv1.controllers.login', [])


    .controller('EntryController', function ($log, $scope, $window, $ionicModal, $ionicLoading, $timeout, $ionicPopup, Login, $location, User, Config, $ionicHistory, $ionicContentBanner, $rootScope, FbLoginService, GoogleLoginService) {

        if (Login.isLogged()) {
            $location.path('/app/propositions/recent');

        }

        /////////////
        // Il y avait ici l'écoute de Facebook
        /////////////


        //$scope.loginData = {username: 'germain.lecourtois@imarkahann.com', password: "pouetpouet"};
        $scope.loginData = {};

        $scope.onLoginClick = function (form) {


            //console.log($scope);

            //console.log(form);


            var aErrors = [];


            if (!form.username.$valid) {

                aErrors.push("Veuillez saisir un e-mail valide");

            }


            if (!form.password.$valid) {


                aErrors.push("Veuillez saisir un mot de passe");

            }


            if (aErrors.length > 0) {

                $ionicContentBanner.show({
                    text: [aErrors[0]],

                    autoClose: 2600,
                    type: 'error',
                    transition: 'vertical'
                });

                return;

            }


            $ionicLoading.show();


            Login.login($scope.loginData.username, $scope.loginData.password)
                .then(function (resolve) {


                    console.log("success ", resolve);
                    var data = resolve.data;
                    if (data.status && data.info && data.info.token) {

                        $scope.token = data.info.token;

                        User.setId(data.info.id);
                        User.setGroup(data.info.group);
                        User.setToken(data.info.token);
                        User.setInst(User.getInstBase());

                        User.store();


                        //Config.default();
                        //Config.setScope('national');


                        Config.load();
                        //Config.store();


                        //console.log('$rootScope.redirect :',$rootScope.redirect)


                        $ionicLoading.hide();


                        $timeout(function () {


                        }, 900);

                        if ($rootScope.redirect && $rootScope.redirect.length > 0) {


                            console.warn("On demande redirect à " + $rootScope.redirect);


                            //$window.location = $rootScope.redirect;


                            $rootScope.auth = true;

                            $location.path($rootScope.redirect + '');

                            $rootScope.redirect = null;
                            delete $rootScope.redirect;


                        } else {


                            $ionicHistory.nextViewOptions({
                                disableBack: true,
                                disableAnimate: true

                            });


                            console.warn("On demande d'aller à /app/propositions/recent");

                            $location.path('/app/propositions/recent');

                        }


                        Config.updateTownName();

                        $scope.token = '';
                        $scope.loginData = {};


                    } else {
                        $scope.token = "Acces refusé";

                        $ionicContentBanner.show({
                            text: ["E-mail ou mot de passe incorrecte"],

                            autoClose: 3000,
                            type: 'error',
                            transition: 'vertical'
                        });


                        $ionicLoading.hide();

                    }


                    Login.isLogged();


                }, function (error) {


                    $ionicLoading.hide();

                    $ionicContentBanner.show({
                        text: ["E-mail ou mot de passe incorrecte"],

                        autoClose: 3000,
                        type: 'error',
                        transition: 'vertical'
                    });

                    $scope.token = "Acces refusé";
                    console.log("error ", error);

                });

        };


        $scope.onSubscribeClick = function () {
            //$ionicLoading.show();


            //$ionicPopup.alert({title: "La possibilité de s'inscrire librement arrive Bientôt !", cssClass:"dark"});


            $location.path('entry/subscribe');


        };


    })


    .controller('SubscribeController', function ($log, Backend, $scope, $window, $rootScope, $ionicModal, $ionicLoading, $ionicPopup, Login, $timeout, $location, User, Config, $ionicHistory, $ionicContentBanner) {


        if (Login.isLogged()) {
            $location.path('/app/propositions/recent');
        }


        $scope.townid = null;

        $scope.nuitdebout = false;

        $scope.sending = false;

        $scope.signupData = {};


        //CAS FACEBOOK
        if ($rootScope.login.type == "facebook") {

            $scope.signupData.nom = $rootScope.login.lastname;
            $scope.signupData.prenom = $rootScope.login.firstname;


        }


        $scope.townurl = Backend.getBaseURL() + "town/find/?key=";


        $scope.onSubmitSignIn = function (form) {


            if ($scope.sending) {
                return;
            }


            $ionicLoading.show();

            console.info("signupData ", $scope.signupData, form);

            var origObject = null;


            $scope.sending = true;

            if (!form.$valid) {


                $ionicContentBanner.show({
                    //text: ["Les informations fournies sont incorrectes"],
                    text: ["Les informations fournies sont incorrectes"],

                    autoClose: 3000,
                    type: 'error',
                    transition: 'vertical'
                });

                $scope.sending = false;


                $ionicLoading.hide();

                return;

            }


            if (($scope.signupData.townselect && $scope.signupData.townselect.originalObject)) {

                //GO !


                /******
                 * ATTENTION il y a un cas email et un cas FB
                 */



                console.info('Lets go !!!', $rootScope.login.type);


                var tempidtown = 1;

                tempidtown = $scope.signupData.townselect.originalObject.id;


                //CAS FACEBOOK
                if ($rootScope.login.type == "facebook") {

                    var email = $rootScope.login.email;
                    var socialid = $rootScope.login.socialid;
                    var socialtoken = $rootScope.login.socialtoken;
                    var lastname = $scope.signupData.nom
                    var firstname = $scope.signupData.prenom;
                    var townid = tempidtown;


                    Login.registerFB(lastname, firstname, townid, email, socialid, socialtoken)
                        .then(function (resolve) {

                            var data = resolve.data;

                            console.log('Retour Register FACEBOOK : ', data);


                            if (data.error) {

                                //console.warn(data.error_message);

                                $ionicContentBanner.show({
                                    text: [data.error_message],

                                    autoClose: 3000,
                                    type: 'error',
                                    transition: 'vertical'
                                });


                                $scope.sending = false;


                            } else {


                                $scope.sending = false;


                                if (data.status && data.info && data.info.token) {

                                    $scope.token = data.info.token;

                                    User.setId(data.info.id);
                                    User.setGroup(data.info.group);
                                    User.setToken(data.info.token);

                                    User.store();


                                    Config.default();


                                    Config.store();


                                    //console.log('$rootScope.redirect :',$rootScope.redirect)


                                    Config.updateTownName();

                                    $scope.token = '';
                                    $scope.loginData = {};


                                    if ($rootScope.redirect) {


                                        $ionicLoading.hide();

                                        //$window.location = $rootScope.redirect;

                                        $location.path($rootScope.redirect);


                                        $rootScope.redirect = null;
                                        delete $rootScope.redirect;


                                    } else {

                                        $ionicLoading.hide();

                                        $ionicHistory.nextViewOptions({
                                            disableBack: true,
                                            disableAnimate: true
                                        });


                                        $rootScope.auth = true;
                                        $location.path('/app/propositions/recent');
                                        //$location.path('/app/propositions/top');
                                        //$window.location.reload();

                                    }


                                    $ionicLoading.hide();

                                    $timeout(function () {

                                        $scope.sending = false;

                                    }, 2300);


                                } else {
                                    $scope.token = "Acces refusé";

                                    $ionicContentBanner.show({
                                        text: ["Une erreur est survenue"],

                                        autoClose: 3000,
                                        type: 'error',
                                        transition: 'vertical'
                                    });


                                    $ionicLoading.hide();

                                    $timeout(function () {


                                        $scope.sending = false;

                                    }, 200);

                                }


                            }

                            Login.isLogged();

                        });


                }


                //CAS EMAIL

                if ($rootScope.login.type == "email") {


                    var email = $rootScope.login.email;

                    // FIXME put this in Service
                    Login.register($scope.signupData.nom, $scope.signupData.prenom, tempidtown, email, $scope.signupData.password)

                        .then(function (resolve) {

                            var data = resolve.data;

                            console.log('Retour Register : ', data);


                            if (data.error) {

                                //console.warn(data.error_message);

                                $ionicLoading.hide();

                                $ionicContentBanner.show({
                                    text: [data.error_message],

                                    autoClose: 3000,
                                    type: 'error',
                                    transition: 'vertical'
                                });


                                $scope.sending = false;


                            } else {


                                if (data.status && data.info && data.info.token) {

                                    $scope.token = data.info.token;

                                    User.setId(data.info.id);
                                    User.setGroup(data.info.group);
                                    User.setToken(data.info.token);
                                    User.setInst(User.getInstBase());

                                    User.store();


                                    Config.default();

                                    if ($scope.nuitdebout) {
                                        Config.setScope('local');
                                    } else {
                                        Config.setScope('candidat');
                                        //Config.setScope('national');
                                    }

                                    Config.store();


                                    //console.log('$rootScope.redirect :',$rootScope.redirect)


                                    Config.updateTownName();

                                    $scope.token = '';
                                    $scope.loginData = {};


                                    if ($rootScope.redirect) {

                                        //$window.location = $rootScope.redirect;

                                        $location.path($rootScope.redirect);


                                        $rootScope.redirect = null;
                                        delete $rootScope.redirect;


                                    } else {


                                        $ionicLoading.hide();

                                        $ionicHistory.nextViewOptions({
                                            disableBack: true,
                                            disableAnimate: true
                                        });


                                        $location.path('/app/propositions/recent');
                                        //$location.path('/app/propositions/top');
                                        $window.location.reload();

                                    }

                                    $ionicLoading.hide();


                                    $timeout(function () {

                                        $scope.sending = false;

                                    }, 2300);


                                } else {
                                    $scope.token = "Acces refusé";


                                    $ionicLoading.hide();

                                    $ionicContentBanner.show({
                                        text: ["E-mail ou mot de passe incorrecte"],

                                        autoClose: 3000,
                                        type: 'error',
                                        transition: 'vertical'
                                    });

                                    $timeout(function () {


                                        $scope.sending = false;

                                    }, 200);

                                }


                            }

                            Login.isLogged();

                        }, function (error) {

                            console.warn('Retour Register error: ', error);


                            $timeout(function () {

                                $scope.sending = false;

                            }, 200);

                        });


                }


            } else {

                $ionicContentBanner.show({
                    text: ["Veuillez choisir une ville parmi la liste proposée", "Un icone (✓) Vous l'indiquera"],

                    interval: 3000,
                    autoClose: 12000,
                    type: 'error',
                    transition: 'vertical'
                });


                $ionicLoading.hide();

                $timeout(function () {

                    $scope.sending = false;

                }, 200);

                return;

            }


        }


    })

    .controller('WizardSubscribeStepOne', function ($log, Backend, $state, $scope, $window, $rootScope, $ionicModal, $ionicLoading, $ionicPopup, Login, $timeout, $location, User, Config, $ionicHistory, $ionicContentBanner) {
        $scope.onCheckForm = function (form) {

            var aErrors = [];


            if (!form.email.$valid) {

                aErrors.push("Veuillez saisir un e-mail valide");

            }

            console.log('Password : ', $scope.signupData.password.length);


            if ($scope.signupData.password.length < 6) {

                aErrors.push("6 caractères minimum pour le mot de passe");

            }



            if (aErrors.length > 0) {

                $ionicContentBanner.show({
                    text: [aErrors[0]],

                    autoClose: 2600,
                    type: 'error',
                    transition: 'vertical'
                });

                return;

            }

            $ionicLoading.show();


            Login.mailCheck($scope.signupData.email).success(function (data, state) {


                $scope.emailSent = true;
                $scope.sending = false;


                $ionicLoading.hide();


                if (data.error) {

                    //console.warn(data.error_message);

                    $ionicContentBanner.show({
                        text: [data.error_message],

                        autoClose: 3000,
                        type: 'error',
                        transition: 'vertical'
                    });


                    $scope.sending = false;


                } else {


                    $rootScope.login.email = $scope.signupData.email;
                    $rootScope.login.type = "email";


                    $scope.signupData = {email: $scope.signupData.email, password: $scope.signupData.password};

                    $state.go('wizardSubscribe.second');
                }


            }).finally(function () {
                $scope.emailSent = true;


                $scope.sending = false;

                $ionicLoading.hide();


            });


        }
    })

    .controller('WizardSubscribeFinal', function ($log, Backend, $state, $scope, $window, $rootScope, $ionicModal, $ionicLoading, $ionicPopup, Login, $timeout, $location, User, Config, $ionicHistory, $ionicContentBanner, $timeout, Town) {
        $scope.signupData.adult = false;


        $scope.townurl = Backend.getBaseURL() + "town/find/?key=";
        $scope.emailSent = false;

        $scope.sending = false;
        $scope.searchNum = '';


        $scope.townSelected = false;


        $scope.town = null;



        $scope.keyboardVisible = false;



        $scope.towns = [];


        $scope.$watch('signupData.townselect', function (val) {
            if (val) {
                $scope.keyboardVisible = false;
            }
        });


        var timerId;
        var timerDelay = 370;

        $scope.$watch('signupData.towntxt', function (val) {
            if (val) {

                console.log("Valeur !");

                $timeout.cancel(timerId);
                timerId = $timeout($scope.searchTown, timerDelay);




            }
        });




        $scope.townComparator = function(t1, t2) {


            console.log(t1,t2);

            return 0;
        }

        $scope.deleteTown = function(){


            if(!$scope.townSelected) return;

            console.log("Delete Town");

            $scope.townSelected = false;
            $scope.town = null;

            $scope.signupData.adult = false;
            $scope.signupData.towntext = "";

        }


        $scope.selectTown = function(t){

            console.log("selectTown : ", t);


            $scope.townSelected = true;


            $scope.town = t;


        }

        $scope.searchTown = function(){

            console.log("Search Town : ", $scope.signupData.towntxt);


            Town.search($scope.signupData.towntxt).then(function(result){

                //console.log(result);

                $scope.towns = result.data.results.slice(0);

            },function(reason){

                console.warn(reason);

            });



        }





        $scope.showKeyboard = function ($event) {
            $scope.keyboardVisible = true;
        };


        $scope.onSubmitFinal = function () {
            console.log($scope.signupData, $rootScope, $rootScope.login.socialid, $rootScope.login.socialtoken);

            // Set throught google connexion (waiting endpoint)
            if (!angular.isDefined($scope.signupData.email)) {
                $scope.signupData.email = $rootScope.login.email;
                $scope.signupData.name = $rootScope.login.firstname;
                $scope.signupData.surname = $rootScope.login.lastname;
            }

            var tempidtown = $scope.town.id,
                email = $scope.signupData.email,
                password = $scope.signupData.password,
                name = $scope.signupData.name,
                surname = $scope.signupData.surname,
                socialid = "",
                socialtoken = "";



            var funcReg = null ;

            if ($rootScope.login && $rootScope.login.type == 'facebook') {

                funcReg = Login.registerFB;
                password = $rootScope.login.socialid;
                socialtoken = $rootScope.login.socialtoken;

            } else {
                funcReg = Login.register;
            }


            funcReg(name, surname, tempidtown, email, password,socialtoken)
            //Login.register(name, surname, tempidtown, email, password)

                .then(function (resolve) {

                    var data = resolve.data;

                    console.log('Retour Register : ', data);


                    if (data.error) {

                        //console.warn(data.error_message);

                        $ionicLoading.hide();

                        $ionicContentBanner.show({
                            text: [data.error_message],

                            autoClose: 3000,
                            type: 'error',
                            transition: 'vertical'
                        });


                        $scope.sending = false;


                    } else {


                        if (data.status && data.info && data.info.token) {

                            $scope.token = data.info.token;

                            User.setId(data.info.id);
                            User.setGroup(data.info.group);
                            User.setToken(data.info.token);
                            User.setInst(User.getInstBase());

                            User.store();


                            Config.default();

                            if ($scope.nuitdebout) {
                                Config.setScope('local');
                            } else {
                                Config.setScope('candidat');
                                //Config.setScope('national');
                            }

                            Config.store();


                            //console.log('$rootScope.redirect :',$rootScope.redirect)


                            Config.updateTownName();

                            $scope.token = '';
                            $scope.loginData = {};


                            if ($rootScope.redirect) {

                                //$window.location = $rootScope.redirect;

                                $location.path($rootScope.redirect);


                                $rootScope.redirect = null;
                                delete $rootScope.redirect;


                            } else {


                                $ionicLoading.hide();

                                $ionicHistory.nextViewOptions({
                                    disableBack: true,
                                    disableAnimate: true
                                });


                                Login.isLogged();
                                $location.path('/app/propositions/recent');

                                //$window.location.reload();

                            }

                            $ionicLoading.hide();


                            $timeout(function () {

                                $scope.sending = false;

                            }, 2300);


                        } else {
                            $scope.token = "Acces refusé";


                            $ionicLoading.hide();

                            $ionicContentBanner.show({
                                text: ["E-mail ou mot de passe incorrecte"],

                                autoClose: 3000,
                                type: 'error',
                                transition: 'vertical'
                            });

                            $timeout(function () {


                                $scope.sending = false;

                            }, 200);

                        }


                    }

                    Login.isLogged();

                }, function (error) {

                    console.warn('Retour Register error: ', error);


                    $timeout(function () {

                        $scope.sending = false;

                    }, 200);

                });

        }


    })

    .controller('MailCheckController', function ($log, Backend, $scope, $window, $rootScope, $ionicModal, $ionicLoading, $ionicPopup, Login, $timeout, $location, User, Config, $ionicHistory, $ionicContentBanner) {


        $scope.loginData = {};


        $scope.signupData = {};
        $scope.signupData.email = "";
        $scope.signupData.ischecked = true;

        $scope.emailSent = false;
        $scope.sending = false;


        $scope.onSubmitMailCheckIn = function (form) {

            var aErrors = [];


            if (!form.email.$valid) {

                aErrors.push("Veuillez saisir un e-mail valide");

            }


            if (aErrors.length > 0) {

                $ionicContentBanner.show({
                    text: [aErrors[0]],

                    autoClose: 2600,
                    type: 'error',
                    transition: 'vertical'
                });

                return;

            }

            $ionicLoading.show();


            Login.mailCheck($scope.signupData.email).success(function (data, state) {


                $scope.emailSent = true;
                $scope.sending = false;


                $ionicLoading.hide();


                if (data.error) {

                    //console.warn(data.error_message);

                    $ionicContentBanner.show({
                        text: [data.error_message],

                        autoClose: 3000,
                        type: 'error',
                        transition: 'vertical'
                    });


                    $scope.sending = false;


                } else {


                    $rootScope.login.email = $scope.signupData.email;
                    $rootScope.login.type = "email";

                    $location.path('/entry/subscribe')


                }


            }).finally(function () {
                $scope.emailSent = true;
                $scope.sending = false;


                $ionicLoading.hide();


            });


        }


    })


    .controller('ResetPasswordController', function ($log, $scope, $rootScope, $ionicModal, $ionicLoading, $timeout, $ionicPopup, Login, $location, User, Config, $ionicHistory, $ionicContentBanner) {


        $scope.loginData = {};


        $scope.emailSent = false;
        $scope.sending = false;

        $scope.onLoginClick = function (form) {


            //console.log($scope);

            //console.log(form);


            var aErrors = [];


            if (!form.username.$valid) {

                aErrors.push("Veuillez saisir un e-mail valide");

            }


            if (aErrors.length > 0) {

                $ionicContentBanner.show({
                    text: [aErrors[0]],

                    autoClose: 2600,
                    type: 'error',
                    transition: 'vertical'
                });

                return;

            }


            $ionicLoading.show();

            $scope.sending = true;

            Login.resetPassword($scope.loginData.username).success(function (data, state) {


                $scope.emailSent = true;
                $scope.sending = false;

                $ionicLoading.hide();

            }).finally(function () {
                $scope.emailSent = true;
                $scope.sending = false;


                $ionicLoading.hide();
            });

        };


    })


;

