"use strict";

angular.module('stigv1.services.googlelogin', [])


    .service('GoogleLoginService', function ($rootScope, $ionicLoading, $ionicContentBanner) {

        "ngInject";

        var vm = this;

        // For Android
        vm.webClientId = "331486738941-l4cpuk3jfdmsom9bd3tbc60in64aldn9.apps.googleusercontent.com";

        vm.signIn = function () {

            window.plugins.googleplus.login(
                {
                    'scopes': '', // optional, space-separated list of scopes, If not included or empty, defaults to `profile` and `email`.
                    'webClientId': vm.webClientId, // optional clientId of your Web application from Credentials settings of your project - On Android, this MUST be included to get an idToken. On iOS, it is not required.
                    'offline': true // optional, but requires the webClientId - if set to true the plugin will also return a serverAuthCode, which can be used to grant offline access to a non-Google server
                },
                function (res) {
                    /**
                     *
                     * res Model result :
                     * res.email          // 'eddyverbruggen@gmail.com'
                     * res.userId         // user id
                     * res.displayName    // 'Eddy Verbruggen'
                     * res.familyName     // 'Verbruggen'
                     * res.givenName      // 'Eddy'
                     * res.imageUrl       // 'http://link-to-my-profilepic.google.com'
                     * res.idToken        // idToken that can be exchanged to verify user identity.
                     * res.serverAuthCode // Auth code that can be exchanged for an access token and refresh token for offline access
                     *
                     * **/

                    Login.mailCheck(res.email).success(function (data) {

                        if (data.error) {
                            displayErrorBanner('Endpoint WIP');
                        } else {
                            $rootScope.login.firstname = res.givenName;
                            $rootScope.login.lastname = res.familyName;
                            $rootScope.login.email = res.email;
                            $rootScope.login.password = res.userId;

                            // FIXME once endpoint done -> put google type
                            $rootScope.login.type = "email";

                            $state.go('wizardSubscribe.third');

                            $ionicLoading.hide();
                        }

                    });

                },
                function (err) {
                    console.log(err);
                    displayErrorBanner('Connexion avec Google refusée');
                }
            );
        };

        // FIXME create an error service to handle it.
        var displayErrorBanner = function (message) {
            $ionicLoading.hide();

            $ionicContentBanner.show({
                text: [message],

                autoClose: 2600,
                type: 'error',
                transition: 'vertical'
            });
        };
    });
