(function () {
	'use strict';

	angular.module('ionic.contrib.ui.ionThread', [])
		.directive('ionComment', ionComment)
		.directive('ionThread', ionThread);

	function ionComment() {
		return {
			restrict: 'E',
			scope: {
				comment: '='
			},
			template: '<ion-item ng-if="comment.data.body.length" class="ion-comment item">\
                        <div   class="ion-comment--score">\
                            <!--<i class="icon ion-arrow-up-a"></i><i class="ion stigicon-amendements"></i>-->\
                        </div>\
                        <div class="ion-comment--author"><span ng-if="comment.data.replies"><i  class="icon ion-pound"></i> </span>{{comment.data.author}}:</div>\
                        \
                        \
                        <div class="ion-comment--text">{{comment.data.body}}</div>\
                        <div ng-if="comment.data.replies" class="ion-comment--replies">{{comment.data.replies.length || "aucune"}} réponse(s) - <span class="ion-comment--answerbutton pointer" ng-click="replyToComment(comment)">Répondre</span></div>\
                        \
                    </ion-item>\
                    ',
			controller: function ($scope) {


				$scope.replyToComment = function () {

					console.info('Repondre ...', $scope, $scope.$parent);

				}
			}
		}
	}

	function ionThread() {
		return {
			restrict: 'E',
			scope: {
				comments: '='
			},
			//Replace ng-if="!comment.showChildren" with ng-if="comment.showChildren" to hide all child comments by default
			//Replace comment.data.replies.data.children according to the API you are using
			template: '<script type="text/ng-template" id="node.html">\
                            <ion-comment  comment="comment">\
                            </ion-comment>\
                            <div class="reddit-post--comment--container">\
                                 <ul ng-if="!comment.showChildren" class="animate-if ion-comment--children">\
                                    <li ng-repeat="comment in comment.data.replies">\
                                        <ng-include src="\'node.html\'"/>\
                                    </li>\
                                </ul>\
                            </div>\
                        </script>\
                        <ion-list ng-if="comments && comments.length > 0">\
                          <ul>\
                            <li ng-repeat="comment in comments">\
                                <ng-include src="\'node.html\'"/>\
                            </li>\
                            \
                            \
                          </ul>\
                        </ion-list>',
			controller: function ($scope) {
				$scope.toggleComment = function (comment) {

					if (comment.showChildren) {
						comment.showChildren = false;
					} else {
						comment.showChildren = true;
					}
				}
			}
		}
	}
})();
